/*
 * Copyright (c) 2005,2015 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _CANIO_H
#define _CANIO_H

#ifdef __cplusplus
extern "C" {
#endif

typedef struct CAN_IO_STR {
	int dev;
	int recMsgId;
	pthread_mutex_t *mutex;
	bool connected;
	int VBattx10;
	unsigned short digiIn;
	unsigned short analogIn[8];
} CAN_IO_STR;

/* Affectation of some digital inputs bits */
#define CAN_IO_EMERGENCY_STOP 0x1000
 
extern CAN_IO_STR *canIOInit(int);
extern void canIOEnd(CAN_IO_STR *);
extern void canIORequestConnect(NEO_STR *);
extern void canIORequestStatus(NEO_STR *);
extern void canIORequestVBatt(NEO_STR *);
extern void canIORequestAnalogIn(NEO_STR *);
extern void canIORequestDigiIn(NEO_STR *);
extern bool canIODecode(CAN_IO_STR *, CAN_MSG *);
extern int canIOGetVBatt(NEO_STR *);
extern unsigned short canIOGetDigiIn(NEO_STR *);
extern void canIOGetAnalogIn(NEO_STR *, unsigned short *);
extern void canIOShow(NEO_STR *);

#ifdef __cplusplus
}
#endif
#endif
